///////////////////////////////////////////////////////////////////////////////
// Defaults:
//

$IRC::AwayMessage = "I'm busy";
$IRC::PartMessage = "Leaving";
$IRC::QuitMessage = "Leaving";

$IRC::Server = "irc.arloria.net";

if ($pref::IRC::Server $= "")
	$pref::IRC::Server = $IRC::Server;
if ($pref::IRC::Port $= "")
	$pref::IRC::Port = 6667;

if ($pref::IRC::Highlight $= "")
	$pref::IRC::Highlight = 1;

if ($pref::IRC::AwayMessage $= "")
	$pref::IRC::AwayMessage = $IRC::AwayMessage;

if ($pref::IRC::PartMessage $= "")
	$pref::IRC::PartMessage = $IRC::PartMessage;

if ($pref::IRC::QuitMessage $= "")
	$pref::IRC::QuitMessage = $IRC::QuitMessage;


///////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
function JoinChatDlg::onWake(%this)
{
	if (!TNIRC.isConnected())
		messageBoxYesNo("Connect IRC","Connect to the IRC server?", "doIRConnect();", "Canvas.popDialog(JoinChatDlg);");
	else
		TNIRC.requestChannelList();
}

//------------------------------------------------------------------------------
function JoinChatList::onAdd( %this )
{
	%this.addColumn(0, "Channel Name", 210, 210, 210);
	%this.addColumn(1, "Users", 74, 74, 74, "numeric center");
	%this.addColumn(2, "", 0, 0, 0, "numeric");
	%this.setSortColumn(2);
	%this.setSortIncreasing(false);
	%this.addStyle(1, $ShellBoldFont, $ShellFontSize, "180 180 180", "220 220 220", "40 40 40");
}
																 
//------------------------------------------------------------------------------
function JoinChatList::onSelect(%this,%id,%text)
{
	JoinChatName.setValue(getField(%text, 0));
}

//------------------------------------------------------------------------------
function JoinChatDlg::join(%this)
{
	%chan = trim(JoinChatName.getValue());

	if (%chan !$= "")
	{
		if (getsubstr(%chan, 0,1) !$= "#")
			%chan = "#" @ %chan;

		TNIRC.send("JOIN" SPC %chan);
		Canvas.popDialog(JoinChatDlg);
		LaunchTabView.viewTab("CHAT", ChatGui, 0);
	}
}

//------------------------------------------------------------------------------
function JoinChatName::onCharInput(%this)
{
	%text = %this.getValue();
	if ( %text !$= "" )
	{
		%count = JoinChatList.rowCount();
		for ( %row = 0; %row < %count; %row++ )
		{
			if ( %text $= getSubStr( getField( JoinChatList.getRowText( %row ), 0 ), 0, strlen( %text ) ) )
				break;
		}

		if ( %row < %count )
			JoinChatList.scrollVisible( %row );
	}
}

//------------------------------------------------------------------------------
function ChatGui::onAdd(%this)
{
	// Add the Member popup menu:
	new GuiControl(ChatMemberActionDlg) {
		profile = "GuiModelessDialogProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		setFirstResponder = "0";
		modal = "1";

		new ShellPopupMenu(ChatMemberPopup) {
			profile = "ShellPopupProfile";
			position = "0 0";
			extent = "0 0";
			minExtent = "0 0";
			visible = "1";
			maxPopupHeight = "200";
			noButtonStyle = "1";
		};
	};
}

//------------------------------------------------------------------------------
function ChatGui::onWake(%this)
{
	Canvas.pushDialog(LaunchToolbarDlg);
	ChatGui.awake = true;
	if (isobject(TNIRC.currentChannel))
	{
		ChatTabView.setSelected(TNIRC.currentChannel);
		ChatGuiScroll.scrollToBottom();
		ChatMessageEntry.schedule(1, makeFirstResponder, true);
	}
}

//------------------------------------------------------------------------------
function ChatGui::setKey(%this,%ignore)
{
}

//------------------------------------------------------------------------------
function ChatTabView::onAdd(%this)
{
	ChatTabView.addSet(1,"gui/shll_horztabbuttonB","5 5 5","50 50 0","5 5 5");

	if ($LaunchMode $= "Normal")
	{
		%this.addTab(TNIRC.getID(), "OPTIONS", 1);
		%this.addTab(TNIRC.serverPane, "SERVER", 1);
	}
	%this.schedule(10, "setSelected", TNIRC.getId());
}

//------------------------------------------------------------------------------
function ChatTabView::onSelect(%this,%obj,%name)
{
	if (%obj == TNIRC.getID())
	{
		ChatPanel.setVisible(false);
		ChatOptionsPanel.setVisible(true);
		ChatChannelTopic.setActive(false);
		ChatClosePaneBtn.setActive(false);
		ChatChannelTopic.setValue("");
		return;
	}

	ChatPanel.setVisible(true);
	ChatOptionsPanel.setVisible(false);
	ChatChannelTopic.setActive(%obj != TNIRC.serverPane);
	ChatClosePaneBtn.setActive(%obj != TNIRC.serverPane);

	ChatTabFrame.setAltColor(%obj.private);
	%priv = TNIRC.self().mode[%obj.getName()];
	ChatEditChannelBtn.setVisible(%priv & ($IRC::Flag::Operator|$IRC::Flag::HalfOp));

	ChatChannelTopic.setValue(%obj.topic);
	if (ChatGui.awake)
	{
		if (TNIRC.currentChannel == TNIRC.attachedChannel)
			ChatGuiMessageVector.detach();

		ChatGuiMessageVector.attach(%obj);
		TNIRC.attachedChannel = %obj;
	}
	TNIRC.currentChannel = %obj;
	TNIRC.refreshUserList();
	ChatMessageEntry.schedule(1, makeFirstResponder, true);
}

//------------------------------------------------------------------------------
function ChatTabView::openNewPane(%this)
{
	Canvas.pushDialog(JoinChatDlg);
}

//------------------------------------------------------------------------------
function ChatTabView::closeCurrentPane(%this)
{
	if (ChatPanel.isVisible() && TNIRC.currentChannel != TNIRC.serverPane)
	{
		if (!TNIRC.currentChannel.private)
			TNIRC.send("PART" SPC TNIRC.currentChannel.getName() SPC $pref::IRC::PartMessage);

		TNIRC.removeChannel(TNIRC.currentChannel.getName());
	}
}

//------------------------------------------------------------------------------
function KeyChannelJoin()
{
	Canvas.popDialog(ChannelKeyDlg);
	TNIRC.send("JOIN " @ TNIRC.keyChannel SPC EditChannelKey.getValue());
	schedule(100, 0, "eval", "TNIRC.channel[TNIRC.keyChannel].key = EditChannelKey.getValue();");
}

//------------------------------------------------------------------------------
function ChatGuiMessageVector::urlClickCallback(%this,%type,%url,%content)
{
	switch$(%type)
	{
	case "http":
		gotoWebPage(%url);
	case "server":
		// Fake server URL for invites
		if (getsubstr(%content, 0,1) $= "#")
			TNIRC.send("JOIN" SPC %content);
		else
			JoinGame(%content);
	case "warrior":
		if ($TN::BrowserEnabled)
			LaunchBrowser(%url,"Warrior");
	default:
		return;
	}
}


//------------------------------------------------------------------------------
function ChatRoomMemberList::onAdd(%this)		 
{
	%o = $IRC::Flag::Operator;
	%h = $IRC::Flag::HalfOp;
	%v = $IRC::Flag::Voice;
	%a = $IRC::Flag::Away;
	%m = $IRC::Flag::Ignore;

	ChatRoomMemberList.addStyle(%o, "op","","","","");
	ChatRoomMemberList.addStyle(%h, "hop","","","","");
	ChatRoomMemberList.addStyle(%v, "voice","","","","");
	ChatRoomMemberList.addStyle(%a, "","","128 128 128","","");
	ChatRoomMemberList.addStyle(%m, "","red","","","");

	ChatRoomMemberList.addStyle(%o|%h, "op","","","","");
	ChatRoomMemberList.addStyle(%o|%v, "op","","","","");
	ChatRoomMemberList.addStyle(%o|%a, "op","","128 128 128","","");
	ChatRoomMemberList.addStyle(%o|%m, "op","red","","","");
	ChatRoomMemberList.addStyle(%h|%v, "hop","","","","");
	ChatRoomMemberList.addStyle(%h|%a, "hop","","128 128 128","","");
	ChatRoomMemberList.addStyle(%h|%m, "hop","red","","","");
	ChatRoomMemberList.addStyle(%v|%a, "voice","","128 128 128","","");
	ChatRoomMemberList.addStyle(%v|%m, "voice","red","","","");
	ChatRoomMemberList.addStyle(%a|%m, "","red","128 128 128","","");

	ChatRoomMemberList.addStyle(%o|%h|%v, "op","","","","");
	ChatRoomMemberList.addStyle(%o|%h|%a, "op","","128 128 128","","");
	ChatRoomMemberList.addStyle(%o|%h|%m, "op","red","","","");
	ChatRoomMemberList.addStyle(%o|%v|%a, "op","","128 128 128","","");
	ChatRoomMemberList.addStyle(%o|%v|%m, "op","red","","","");
	ChatRoomMemberList.addStyle(%o|%a|%m, "op","red","128 128 128","","");
	ChatRoomMemberList.addStyle(%h|%v|%a, "hop","","128 128 128","","");
	ChatRoomMemberList.addStyle(%h|%v|%m, "hop","red","","","");
	ChatRoomMemberList.addStyle(%h|%a|%m, "hop","red","128 128 128","","");
	ChatRoomMemberList.addStyle(%v|%a|%m, "voice","red","128 128 128","","");

	ChatRoomMemberList.addStyle(%o|%h|%v|%a, "op","","128 128 128","","");
	ChatRoomMemberList.addStyle(%o|%h|%v|%m, "op","red","","","");
	ChatRoomMemberList.addStyle(%o|%h|%a|%m, "op","red","128 128 128","","");
	ChatRoomMemberList.addStyle(%o|%v|%a|%m, "op","red","128 128 128","","");
	ChatRoomMemberList.addStyle(%h|%v|%a|%m, "hop","red","128 128 128","","");

	ChatRoomMemberList.addStyle(%o|%h|%v|%a|%m, "op","red","128 128 128","","");
}


//------------------------------------------------------------------------------
function ChatRoomMemberList::onRightMouseDown(%this,%column,%row,%mousePos)
{
	%chan = TNIRC.currentChannel;

	// Show the menu
	ChatMemberPopup.member = %this.getRowId(%row);
	ChatMemberPopup.position = %mousePos;
	ChatMemberPopup.clear();

	// Find the user
	%user = %chan.user[%row];
	%privs = %user.mode[%chan.getName()];
	%self = TNIRC.self();
	%myPrivs = %self.mode[%chan.getName()];
	%op = $IRC::Flag::Operator;

	// Push their name, and an "underline"
	ChatMemberPopup.add(%user.nick, 7);
	for (%i = 0; %i < strlen(%user.nick) * 1.5; %i++)
		%line = %line @ "-";
	ChatMemberPopup.add(%line, -1);

	if (%user == %self)
	{
		if (%myPrivs & $IRC::Flag::Away)
			ChatMemberPopup.add("Mark Unaway", 0);
		else
			ChatMemberPopup.add("Mark Away", 1);
	}
	else
	{
		if (!%chan.private)
			ChatMemberPopup.add("Chat", 2);

		if (%myPrivs & $IRC::Flag::Operator && !(%privs & %op))
			ChatMemberPopup.add("Give half-op", 3);

		if (%myPrivs & %op && !(%privs & %op))
		{
			ChatMemberPopup.add("Kick", 4);
			ChatMemberPopup.add("Ban", 5);
		}

		if (%user.ignore)
			ChatMemberPopup.add("Unignore", 6);
		else
			ChatMemberPopup.add("Ignore", 6);

		if ($TN::BrowserEnabled)
		{
			ChatMemberPopup.add(%line, -1);
			ChatMemberPopup.add("T-Mail", 10);
			ChatMemberPopup.add("Add to Buddy List", 11);
		}
	}

	Canvas.pushDialog(ChatMemberActionDlg);
	ChatMemberPopup.forceOnAction();
}


function ChatMemberPopup::onSelect(%this,%id,%text)
{
	%chan = TNIRC.currentChannel.getName();
	%user = TNIRC.currentChannel.user[%this.member];

	switch(%id)
	{
	case 0:// Set unaway
		TNIRC.send("AWAY");
	case 1:// Set away
		TNIRC.send("AWAY :" @ $pref::IRC::AwayMessage);
	case 2:// Private chat
		if (TNIRC.channel[%user.nick] $= "")
			TNIRC.addChannel(%user.nick);
	case 3:// Make them a half-op
		TNIRC.send("MODE" SPC %chan SPC "+h" SPC %user.nick); 
	case 4:// Kick
		TNIRC.send("KICK" SPC %chan SPC %user.nick);
	case 5:// Ban
		TNIRC.send("MODE" SPC %chan @ "+b" @ %user.login);
		TNIRC.send("KICK" SPC %chan SPC %nick);
	case 6:
		%user.ignore = !%user.ignore;
		TNIRC.refreshUserList();
	case 10:
		messageBoxOK("Not yet implemented!", "This feature is forthcoming!");
	case 11:
		messageBoxOK("Not yet implemented!", "This feature is forthcoming!");
	}
}


//------------------------------------------------------------------------------
function ChatMessageEntry::onTabComplete(%this)
{
	%channel = TNIRC.currentChannel;
	%text = %this.getValue();
	%len = strlen(%text);
	%cursor = %this.getCursorPos();

	for (%begin = %cursor; %begin > 0; %begin--)
	{
		if (getsubstr(%text, %begin, 1) $= " ")
		{
			%begin++;
			break;
		}
	}

	for (%end = %cursor; %end < %len; %end++)
	{
		if (getsubstr(%text, %end, 1) $= " ")
			break;
	}

	// Move cursor to the end...
	%this.setCursorPos(%end);

	%wLen = %end - %begin;
	%word = getsubstr(%text, %begin, %wLen);

	// If last completion, continue through the cycle...
	if (%word $= TNIRC.lastCompletion)
	{
		%word = TNIRC.lastCompletionStub;
		%wLen = strlen(%word);
	}

	// See if it's in a persons name!
	%matches = 0;
	for (%i = 0; %i < %channel.users; %i++)
		if (getsubstr(%channel.user[%i].nick, 0, %wLen) $= %word)
		{
			%match[%matches] = %channel.user[%i].nick;
			%matches++;
		}

	if (!%matches)
		return;

	// Find the next one to use...
	for (%i = 0; %i < %matches; %i++)
		if (%match[%i] $= TNIRC.lastCompletion)
		{
			%next = %match[%i+1];
			break;
		}

	if (%next $= "")
		%next = %match[0];

	%diff = strlen(%next) - %wLen;
	if (%next $= "")
		return;

	%cursor = %this.getCursorPos();
	%pre = getsubstr(%text, 0, %begin);//%cursor - %wLen);
	%post = getsubstr(%text, %cursor, strlen(%text));

	%this.setCursorPos(%cursor + %diff - 1);
	%this.setValue(%pre @ %next @ %post);

	TNIRC.lastCompletion = %next;
	TNIRC.lastCompletionStub = %word;
}


//------------------------------------------------------------------------------
function IRCClient::onJoinGame(%address, %desc)
{
	// 0: name
	// 1: address
	// 2: Rule Set
	// 3: Status
	// 4: Mission Type
	// 5: Mission Name
	// 6: Info

	%info = GMJ_Browser.getServerInfoString();
	%mesg = "Playing on" SPC getField(%info, 0);

	if ($pref::Net::DisconnectChat)
		TNIRC.disconnect(%mesg);
	else
		TNIRC.send("AWAY :" @ %mesg);
}


function IRCClient::onLeaveGame()
{
	TNIRC.send("AWAY");
}


//------------------------------------------------------------------------------
function doIRConnect()
{
	if (TNIRC.isConnected())
		return;

	ChatOpt_Conn.setActive(false);

	TNIRC.connect($pref::IRC::Server, $pref::IRC::Port, $pref::IRC::Passwd);
}


function doIRCDisconnect()
{
	ChatOpt_DConn.setActive(false);
	ChatOpenPaneBtn.setActive(false);
	TNIRC.disconnect();
}


function sendChatText()
{
	%chan = TNIRC.currentChannel.getName();
	%text = ChatMessageEntry.getValue();
	ChatMessageEntry.setValue("");

	TNIRC.sendMessage(%chan, %text);
}


function setChanTopic()
{
	%topic = ChatChannelTopic.getValue();
	%chan = TNIRC.currentChannel;

	if (%chan.topic !$= trim(%topic))
		TNIRC.send("TOPIC" SPC %chan.getName() SPC %topic);
}


function editChanOpts()
{
	%chan = TNIRC.currentChannel;

	ButtonChannelInvite.setValue(%chan.mode & $IRC::CFlag::Invite);
	ButtonChannelModerate.setValue(%chan.mode & $IRC::CFlag::Moderated);
	ButtonChannelLimit.setValue(%chan.mode & $IRC::CFlag::Limited);
	EditChannelMaxMembers.setValue(%chan.limit);
	ButtonChannelKey.setValue(%chan.mode & $IRC::CFlag::HasKey);
	EditChannelPassword.setValue(%chan.key);

	Canvas.pushDialog(ChannelOptionsDlg);
}


function applyChanOpts()
{
	Canvas.popDialog(ChannelOptionsDlg);
	%s = "MODE" SPC TNIRC.currentChannel.getName();

	TNIRC.send(%s SPC (ButtonChannelInvite.getValue() ? "+i" : "-i"));
	TNIRC.send(%s SPC (ButtonChannelModerate.getValue() ? "+m" : "-m"));
	TNIRC.send(%s SPC (ButtonChannelLimit.getValue() ? "+l" SPC EditChannelMaxMembers.getValue() : "-l"));
	TNIRC.send(%s SPC (ButtonChannelKey.getValue() ? "+k" SPC EditChannelPassword.getValue() : "-k"));
}


package IRC_HOOKS
{
	function Quit()
	{
		// Send our quit-message
		TNIRC.send("QUIT :" @ $pref::IRC::QuitMessage);

		parent::Quit();
	}


	// Taken from UEfix.cs by LouCypher, slightly modified by Thyth
	function MessageVector::pushBackLine(%this, %text, %tag)
	{
		// Use lowercase for string comparisons
		%lwr = strlwr(%text);

		// Check for <tribe>..</tribe> tags
		%start = strstr(%lwr, "<tribe:");
		if (%start != -1)
		{
			%end = strstr(%lwr, "</tribe");
			%str = getsubstr(%lwr, %start, %end - %start);
			if (strstr(%str, ">") == -1)
			{
				error("MessageVector::pushBackLine - Exploit detected!");
				warn("Line: " @ %text);
				return;
			}
		}

		// Check for <t2server>...</t2server> tags
		%start = strstr(%lwr, "<t2server:");
		if (%start != -1)
		{
			%end = strstr(%lwr, "</t2server");
			%str = getsubstr(%lwr, %start, %end - %start);
			if (strstr(%str, ">") == -1)
			{
				error("MessageVector::pushBackLine - Exploit detected!");
				warn("Line: " @ %text);
				return;
			}
		}

		// No exploit attempts, continue...
		parent::pushBackLine(%this, %text, %tag);
	}

	function alxGetWaveLen(%wavFile)
	{
		if ( strstr( %wavFile , ".wav" ) == -1 )
			return $MaxMessageWavLength + 1;
		parent::alxGetWaveLen(%wavFile);
	}
};
if (!isActivePackage(IRC_HOOKS))
	activatePackage(IRC_HOOKS);


